#ifndef __HITECK_NTALK_H
#define __HITECK_NTALK_H

#include <time.h>
#include <curses.h>
#include <signal.h>

#include "ipc_msg.h"
#include "ipc_shm.h"
#include "vt100.h"

#define T_VERSION "1.2.0"

#define CMDCHAR     '/'
#define ROOMNAME    "dungeon"

/* chat msgkeys */
#define M_ENTER		1
#define M_LEAVE		2
#define M_MSG		3
#define M_TTTMOVE	4
#define M_TTTJOIN       5

#define UM_NORMAL       0
#define UM_BUSY         1
#define UM_TTT_SERVER   2


/* operation modes */
#define MODE_NORMAL 1
#define MODE_TTT    2

/* system msgkeys */
#define S_GIVEUSERS 255
#define S_USERINFO  254

#define MAX_USERS   128
#define USER_SCALAR  64

#define MAX_INPUT_LENGTH 256

extern int	qid, smid;
extern char	u_lname[16];
extern short	u_tid;
extern char	u_idstring[32];
extern char	u_input[MAX_INPUT_LENGTH];
extern int	u_input_pos;

typedef struct
{
	int	tid, mode;
	char	name[16];
} user_t;

extern user_t	*r_user;
extern user_t   me;
extern int	me_index;
extern int	t_mode;
extern int	last_msg_t;
extern char	*last_msg;


extern void msg_send(long type, char *data);
extern void msg_sendpriv(int user, long type, char *data);
extern void msg_broadcast(long type, char *data);
extern int  msg_handle();
extern int  t_input();
extern void remove_dead_users();
extern void t_print_users();
extern void t_print_input();
extern void t_printmsg(char *text);
extern void delay();
extern void str_lcase(char *str);
extern int  t_parsecmd(char *cmd);
extern void sig_int();
extern int  user_index(char *name);
extern void t_leave();
#endif
