#include <time.h>
#include <curses.h>
#include <signal.h>

#include "ipc_msg.h"
#include "ipc_shm.h"
#include "vt100.h"
#include "ntalk.h"


void main(int argc, char *argv[])
{
	char buffer[256];
	long t_start;
	int i, j, k;
	
	t_mode = MODE_NORMAL;

	signal(SIGINT, sig_int);

	initscr();
	refresh();
	sprintf(buffer, "%s NTalk v%s (build %s) by Sami Kyostila                              %s\r\n", VT_REVERSE, T_VERSION, __DATE__, VT_NORMAL);
	t_printmsg(buffer);

	qid = ipc_init(666);
	smid = ipc_init_shm(666, MAX_USERS*sizeof(user_t)+1);
	
	cuserid(me.name);
	me.tid = getpid()&0xffff;
	
	sprintf(buffer, "*** Opened ipc_msgqueue %d, ipc_shmsegment %d", qid, smid);
	t_printmsg(buffer);

	r_user = (user_t*)ipc_smptr(smid);

	me_index = -1;
	remove_dead_users();	

	for (i=0; i<MAX_USERS+1; i++)
	{
		if (i==MAX_USERS)
		{
			t_printmsg("*** Max user count reached.");
			return;
		}
		if (r_user[i].tid==0) break;
	}

	me_index = i;
	memcpy(&r_user[me_index], &me, sizeof(user_t));

	sprintf(buffer, "*** I am Borg %d of %d. Resistance is futile.", me_index, MAX_USERS);
	t_printmsg(buffer);

	t_print_users();

        msg_send(M_ENTER, me.name);
	refresh();

        cbreak(); noecho(); nonl(); timeout(5);

	for (;;)
	{
		if (msg_handle()) break;
		if (t_input()) break;
	}

        nocbreak(); echo(); nl();

	t_leave();
	endwin();
}
